/*
 * net.h
 *
 * Copyright 2004, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * ͥåȥ̥إå
 */


#ifndef net_h
#define net_h


#include<types.h>
#include<share/socket.h>
#include<share/in.h>


#ifndef ASM_FILE


typedef struct{
	char  *data[3];		/* ե졼ॢɥ쥹 */
	int    size[3];		/* ǡե졼ॵ */
	ushort type;		/* ե졼ॿס */
	uchar  ipType;		/* IPץȥ륿ס */
}TRANS_BUF_INFO;

typedef struct SOCKET{
	ushort     form;	/* եμࡣ */
	in_port_t  port;
	void      *sinf;	/* SOCKET_INFO. */
	void      *buf;
}SOCKET;

typedef struct{
	/* parameters : socket,message,message length,flag,struct sockaddr */
	void (*send)(SOCKET*,const void *msg,size_t len,int flags,struct sockaddr *to);
	/* parameters : socket,buffer,buffer size,flag,struct sockaddr,struct sockaddr length pinter
	   return : copy size or error number  */
	int (*recv)(SOCKET*,void *buf,size_t len,int flags,struct sockaddr *from,socklen_t *fromlen);
}SOCKET_INFO;


static inline ushort swapWord(ushort value)
{
	return (value>>8)+(value<<8);
}

extern ushort calcSum(uint*,int);
extern ushort calcSumM(uint*,uint*,int,int);
extern void closeSocket(SOCKET*);
extern int sys_socket();
extern int sys_send();
extern int sys_recv();
extern int registSocket(SOCKET_INFO*,int);
extern int initNet();


#endif


#endif
